#include "povS1.h"
#include "bluetooth.h"

extern volatile char msg[MAX_MSG+1];
extern volatile unsigned int LedsArray[60] ;
extern unsigned char hour,min,sec ;
extern unsigned int vbat ;
extern unsigned int n0 ;

unsigned int ReadVBAT(void) ;
void LedsUpdateTime(void);

// les commandes sont de la forme : C:PARM1[:PARM2[:PARMx...]]]
// C est un caractre qui dfinit le type de commande
// Lorsque PARM1 vaut ? on rpond la valeur du paramtre actuel
// Sinon Les PARMx fixent les valeurs des paramtres
int execute_command(void) {
 
    unsigned char new_hour,new_min,new_sec ;
    int ercode = -1;  ;

  //  printf("Rx:%s\r\n",msg);
    if (msg[1] != ':') {
        printf("?\r\n$");
        return -1 ;
    }
    switch (msg[0]) {
        
        case 'H' : // cmd heure
            if ( msg[2]=='?')  { // affiche heure
                printf("H:%02d:%02d:%02d",hour,min,sec);
                ercode = 0 ;
            } else {
            // mise  l'heure
            new_hour = atoi(msg+2);
            new_min  = atoi(msg+5);
            new_sec = atoi(msg+8);
            if (new_hour<12 && new_min<60 && new_min <60) {
                    hour = new_hour ;
                    min = new_min ;
                    sec = new_sec ;
                    LedsUpdateTime();
                    printf("New time is\r\nH:%02d:%02d:%02d",hour,min,sec);
                    ercode = 0 ;
                }
            else {
                    printf("New time : %02d:%02d:%02d not valid !",\
                                                   new_hour,new_min,new_sec);
                    ercode = -1 ;
               }
            }
           
            break ;
        case 'V': // tension batterie
            if ( msg[2]=='?')  {
               vbat = ReadVBAT();
               printf("VBAT : %d mV",vbat) ;
               ercode = 0 ;
            }
            break ;
        case 'R': // revision
             if ( msg[2]=='?')  {
                 printf(VERSION);
                 ercode = 0 ;
             }
             break ;
        case 'N' :  // vitesse de rotation
             if ( msg[2]=='?')  {
                 printf("N0=%u",n0);
                 ercode = 0 ;
             }
             break ;
        default :
            ercode = -1 ;
    } 
    printf("\r\n$") ;
    return ercode ;

}

void LedsUpdateTime(void) {

    int i ;
    // RAZ leds
    for (i=0;i<60;i++){
        LedsArray[i]=0 ;
    }
    // Aiguilles minute et heure
    LedsArray[min]=0x0FFF;
    LedsArray[hour*5]=0x0FF0;
    // Tour des secondes
   for (i=0;i<=sec;i++) {
      LedsArray[i]|=1;
    }
}