#include <timers.h>
#include "povS1.h"
//prototypes des gestionnaires d'interruption
void InterruptHandlerHigh (void);
void InterruptHandlerLow (void);
void BinToLeds( unsigned int value) ;
void DisplaySpeed( unsigned int n0 );

extern volatile unsigned int LedsArray[60] ;
extern volatile unsigned char LowSpeed ;
unsigned int n0,n3 ;
char Ovf = 0  ;
unsigned int tabn0[10],j=0,k,sn0;

unsigned char hour=3,min=35,sec,NItTimer1;

//Placement d'un saut vers le gestionnaire d'interruption
//----------------------------------------------------------------------------
// High priority interrupt vector
#pragma code InterruptVectorHigh = 0x08
void
InterruptVectorHigh (void)
{
  _asm
    goto InterruptHandlerHigh //jump to interrupt routine
  _endasm
}
// Low priority interrupt vector
#pragma code InterruptVectorLow = 0x18
void
InterruptVectorLow (void)
{
  _asm
    goto InterruptHandlerLow //jump to interrupt routine
  _endasm
}
// Routines gestionnaire d'interruption
//----------------------------------------------------------------------------
// High priority interrupt routine
#pragma code
#pragma interrupt InterruptHandlerHigh
void
InterruptHandlerHigh ()
{
     static unsigned char i , clr=0;
    unsigned char j ;
   // IT overflow timer 0
   // si cette IT apparait on tourne trop lentement
    if ( INTCONbits.TMR0IF) {

        LowSpeed = 1 ;
        Ovf = 1 ;
        n0=0;
        INTCONbits.TMR0IF = 0 ;
    }

    // IT REF 0 tour
    if ( INTCONbits.INT0IF) {
        //IntToLeds(LedsArray[0]);
     // if ( Ovf == 1 ) {  //   Pas de mise  jour vitesse si overflow
        n0 = ReadTimer0();
      /*  tabn0[j]=n0;
        if ( j < 9) j++; else j=0;
        sn0=0;
        for(k=0;k<9;k++) sn0=sn0+tabn0[k];
      */
        n3 = (n0*32L)/120; // Timer3 va 32 fois plus vite que timer0
        if ( n0 > 37500 ) { // TODO : crer Macro en fonction de FOSC
            LowSpeed = 1 ;

        } else {
            LowSpeed = 0 ;


                   }
      //} else {
        //  Ovf = 0 ;
      //}
        WriteTimer0(0); // RAZ timer0;
        WriteTimer3(0xFFFF - n3);
        BinToLeds(LedsArray[0]);
        i=1;
        clr=1;
        PIR2bits.TMR3IF = 0 ;
        INTCONbits.INT0IF = 0 ;
      // DisplaySpeed(  n0 ) ;

         // IntToLeds(LedsArray[1]);
      }

    // IT 1/120 tour
    if ( PIR2bits.TMR3IF ) {
        if (!LowSpeed) {
        if (!clr){

         //    LED0 = !LED0 ;
          BinToLeds(LedsArray[i]);
            if ( i< 59 )  i++;  else i=0 ;
        } else
            BinToLeds(0);
        clr = 1 - clr ;
        }
       WriteTimer3(0xFFFF - n3) ;
       PIR2bits.TMR3IF = 0 ;
    }
    // IT 50ms timer1
    // pour 1s on compte 1s/50ms = 20 it
    if ( PIR1bits.TMR1IF) {

        WriteTimer1(3036) ;
        PIR1bits.TMR1IF = 0 ;

        if (NItTimer1 >=5  ) { // 5it pour tx4 !!
            NItTimer1 = 0 ;
           // LedsArray[sec]=0;
            LedsArray[min]=0;
            LedsArray[hour*5]=0;
             if ( sec < 59 ) { sec++;}
             else {
                 sec = 0 ;
                 for (j=0;j<60;j++)
                 { LedsArray[j]=0x0; }
                 if ( min < 59 ) { min++; }
                 else {
                     min = 0 ;
                     if ( hour < 11) { hour++ ; }
                     else { hour = 0 ; }
                 }
             }
            LedsArray[min]=0x0FFF;
            LedsArray[hour*5]=0x0FF0;
            LedsArray[sec]|=1;
        } else
        {
            NItTimer1++;
        }
    }
}

extern volatile char msg[MAX_MSG+1];
extern volatile unsigned char rx ;
// Low priority interrupt routine
#pragma code
#pragma interrupt InterruptHandlerLow
void
InterruptHandlerLow ()
{

  static char i ; 
   char c ;
  // Partie rception d'un caractre
  if(PIR1bits.RCIF) // si un car arriv
    {
      c=ReadUSART(); // le lire
      WriteUSART(c); // echo
      if (c==CAR_LF) return ; // ignore les LF
      if( c==CAR_BS)
        {
         if(i>0){
             i--;  }
        }
      else {
        if(c!=CAR_CR && i<MAX_MSG)
         {
           msg[i++]=c ; // stockage
         }else
         {
           msg[i]='\0'; // fin de chane si CR
           i=0;
           rx=1;
         }
      }
    }
}

