#ifndef __POV_H
#define __POV_H
#include <stdio.h>
#include <stdlib.h>
#include <p18cxxx.h>
#include <delays.h>
#include <timers.h>
#include <adc.h>
#include <usart.h>

#define VERSION "GEII POV CLOCK V1.2"
// system defs
#define SYS_FREQ 40E6 // Qz=10Mhz x4 (HSPLL)
#define SYS_TCY  (4./SYS_FREQ)
#define SECOND_TCY   (1./SYS_TCY)
#define SECOND_1OKTCY ( SECOND_TCY / 10E3 )

// Led defs
#define LED0 LATAbits.LATA4
#define LED1 LATAbits.LATA5
#define THERM_ON LED1 // Led1 commande aussi la tension sur RTH

#define LED0to1  LATA
#define TRISLED0to1  TRISA
#define LED0to1_OUTPUT 0b11001111

#define LED2 LATCbits.LATC0
#define LED3 LATCbits.LATC1
#define LED4 LATCbits.LATC2
#define LED5 LATCbits.LATC3
#define LED6 LATCbits.LATC5  //  inverser !!
#define LED7 LATCbits.LATC4   //  inverser !!


#define LED2to7 LATC
#define TRISLED2to7 TRISC
#define LED2to7_OUTPUT 0b11000000

#define LED8 LATBbits.LATB2
#define LED9 LATBbits.LATB3
#define LED10 LATBbits.LATB4
#define LED11 LATBbits.LATB5

#define LED8to11 LATB
#define TRISLED8to11 TRISB
#define LED8to11_OUTPUT 0b11000011

#define LED_OFF 0
#define LED_ON 1

// logical inputs defs
#define BP1 PORTBbits.RB1
#define REF_INPUT PORTBbits.RB0
#define BP2 REF_INPUT
#define SW_PORT PORTB

// analog inputs defs
#include  <adc.h>
#define CH_TEMP ADC_CH3
#define CH_MVBAT ADC_CH2
#define MVABT_RATIO 3

// uart defines
#define MAX_MSG 20
#define CAR_CR 0x0D
#define CAR_LF 0x0A
#define CAR_BS 0x08

#endif